aboutsummaryrefslogtreecommitdiff
path: root/src/on_ac_power
diff options
context:
space:
mode:
authorWilliam Hubbs <w.d.hubbs@gmail.com>2022-04-06 10:51:55 -0500
committerWilliam Hubbs <w.d.hubbs@gmail.com>2022-04-06 10:51:55 -0500
commit391d12db48754861b5cecac92ee3321597ee02c1 (patch)
treeb42fad5a31ca342de7b7ecf1fb78784194c1400c /src/on_ac_power
parent0efc1b133e4182bd53cde78153bd8b5cc2e99448 (diff)
migrate fully to meson build system
- drop old build system - move shared include and source files to common directory - drop "rc-" prefix from shared include and source files - move executable-specific code to individual directories under src - adjust top-level .gitignore file for new build system This closes #489.
Diffstat (limited to 'src/on_ac_power')
-rw-r--r--src/on_ac_power/meson.build3
-rw-r--r--src/on_ac_power/on_ac_power47
2 files changed, 50 insertions, 0 deletions
diff --git a/src/on_ac_power/meson.build b/src/on_ac_power/meson.build
new file mode 100644
index 00000000..aedc4daa
--- /dev/null
+++ b/src/on_ac_power/meson.build
@@ -0,0 +1,3 @@
+install_data('on_ac_power',
+ install_dir : rc_bindir,
+ install_mode: 'rwxr-xr-x')
diff --git a/src/on_ac_power/on_ac_power b/src/on_ac_power/on_ac_power
new file mode 100644
index 00000000..a4c1cf9c
--- /dev/null
+++ b/src/on_ac_power/on_ac_power
@@ -0,0 +1,47 @@
+#!/bin/sh
+# Detect AC power or not in a portable way
+# Exit 0 if on AC power, 1 if not and 255 if we don't know how to work it out
+
+# Copyright (c) 2007-2015 The OpenRC Authors.
+# See the Authors file at the top-level directory of this distribution and
+# https://github.com/OpenRC/openrc/blob/HEAD/AUTHORS
+#
+# This file is part of OpenRC. It is subject to the license terms in
+# the LICENSE file found in the top-level directory of this
+# distribution and at https://github.com/OpenRC/openrc/blob/HEAD/LICENSE
+# This file may not be copied, modified, propagated, or distributed
+# except according to the terms contained in the LICENSE file.
+
+if [ -f /proc/acpi/ac_adapter/*/state ]; then
+ cat /proc/acpi/ac_adapter/*/state | while read line; do
+ case "$line" in
+ "state:"*"off-line") exit 128;;
+ esac
+ done
+elif [ -d /sys/class/power_supply ]; then
+ for dir in /sys/class/power_supply/*/; do
+ [ "$(cat "${dir}/type")" != "Mains" ] && continue
+ [ "$(cat "${dir}/online")" = 0 ] && exit 128
+ done
+elif [ -f /proc/pmu/info ]; then
+ cat /proc/pmu/info | while read line; do
+ case "$line" in
+ "AC Power"*": 0") exit 128;;
+ esac
+ done
+elif command -v envstat >/dev/null 2>&1; then
+ # NetBSD has envstat
+ envstat -d acpiacad0 2>/dev/null | while read line; do
+ case "$line" in
+ "connected:"*"OFF") exit 128;;
+ esac
+ done
+elif sysctl -q hw.acpi.acline >/dev/null 2>/dev/null; then
+ case $(sysctl -n hw.acpi.acline) in
+ 0) exit 1;;
+ *) exit 0;;
+ esac
+else
+ exit 255
+fi
+[ $? != 128 ]